【力扣】第 280 场力扣周赛复盘

简介: 【力扣】第 280 场力扣周赛复盘

一、引言

今天的周赛打的一言难尽,由于一个简单的 long 转换疏忽导致自己 T3 没A

二、 6004. 得到 0 的操作数

1、题目简介

2、题目解析

  • 模拟即可
  • 注意返回的条件:while(num1 != 0 && num2 != 0)

3、题目代码

class Solution {
    public int countOperations(int num1, int num2) {
        int count = 0;
        while(num1 != 0 && num2 != 0){
            if(num1 >= num2){
                num1 = num1 - num2;
            }else{
                num2 = num2 - num1;
            }
            count++;
        }
        return count;
    }
}

三、6005. 使数组变成交替数组的最少操作数

1、题目简介

2、题目解析

  • 贪心
  • 我们分析题目,简单的来讲,最后的结果:我们奇数位是同一个数字,偶数位是同一个数字,并且数字不能相等
  • 我们使用两个优先队列存储其次数,根据 出现最多的次数 进行判断
  • 我们考虑以下几种情况:
  • [0]:队列二为空
  • [1,2]:队列一和队列二大小均为1
  • [1,2,3]:队列一大小为2,队列二大小为1
  • [1,2,3,4]:队列一大小为2,队列二大小为2
  • 我们比较优先队列的 int value = peek() ,数字出现的次数
  • 如果不相等的话,说明最终都需要变成 value,计算其次数即可
  • 如果相等的话,我们需要比较 value 的大小,大的保持原状,小的需要变成 第二大的

3、题目代码

class Solution {
    public static int minimumOperations(int[] nums) {
        if (nums.length == 1) {
            return 0;
        }
        HashMap<Integer, Integer> map1 = new HashMap<>();
        HashMap<Integer, Integer> map2 = new HashMap<>();
        int count1 = 0;
        int count2 = 0;
        for (int i = 0; i < nums.length; i++) {
            if (i % 2 != 0) {
                count1++;
                map1.put(nums[i], map1.getOrDefault(nums[i], 0) + 1);
            } else {
                count2++;
                map2.put(nums[i], map2.getOrDefault(nums[i], 0) + 1);
            }
        }
        // 奇数
        PriorityQueue<int[]> priorityQueue1 = new PriorityQueue<>(new Comparator<int[]>() {
            @Override
            public int compare(int[] o1, int[] o2) {
                return o2[1] - o1[1];
            }
        });
        for (Integer key : map1.keySet()) {
            priorityQueue1.add(new int[]{key, map1.get(key)});
        }
        // 偶数
        PriorityQueue<int[]> priorityQueue2 = new PriorityQueue<>(new Comparator<int[]>() {
            @Override
            public int compare(int[] o1, int[] o2) {
                return o2[1] - o1[1];
            }
        });
        for (Integer key : map2.keySet()) {
            priorityQueue2.add(new int[]{(int) key, (int) map2.get(key)});
        }
        if (priorityQueue1.size() == 1 && priorityQueue2.size() == 1) {
            if (priorityQueue1.peek()[0] != priorityQueue2.peek()[0]) {
                return 0;
            } else {
                return priorityQueue1.peek()[1] >= priorityQueue2.peek()[1] ? priorityQueue2.peek()[1] : priorityQueue1.peek()[1];
            }
        }else if (priorityQueue1.size() > 1 && priorityQueue2.size() == 1) {
            if (priorityQueue1.peek()[0] != priorityQueue2.peek()[0]) {
                return count1 - priorityQueue1.peek()[1];
            } else {
                if (priorityQueue1.peek()[1] >= priorityQueue2.peek()[1]) {
                    return count2 + count1 - priorityQueue1.peek()[1];
                } else {
                    priorityQueue1.poll();
                    return count1 - priorityQueue1.peek()[1];
                }
            }
        } else {
            if (priorityQueue1.peek()[0] != priorityQueue2.peek()[0]) {
                return count1 - priorityQueue1.peek()[1] + count2 - priorityQueue2.peek()[1];
            } else {
                if (priorityQueue1.peek()[1] >= priorityQueue2.peek()[1]) {
                    priorityQueue2.poll();
                    return count1 - priorityQueue1.peek()[1] + count2 - priorityQueue2.peek()[1];
                } else {
                    priorityQueue1.poll();
                    return count1 - priorityQueue1.peek()[1] + count2 - priorityQueue2.peek()[1];
                }
            }
        }
    }
}

四、6006. 拿出最少数目的魔法豆

1、题目简介

2、题目解析

  • 我们发现,我们要想使魔法豆相等,需要找到一个临界点,根据这个临界点:小于他的全部变成0,大于他的全部变成成它
  • 先进行排序
  • 我们以 [1,4,5,6] 作为例子
  • 假设当前的临界点为5,那么我们的 1、4 需要变为 06 变成 5,最后的结果为:7
  • 由于我们的魔法豆没办法增加,只能减少
  • 当我们遍历其数值时,我们将
  • 整体的和 - 后面的数据个数 * 当前的值
  • 注意,我们在求值的时候,千万不要忘了将类型转为 long
  • 这个题目也可以使用 前缀和

3、题目代码

class Solution {
   public long minimumRemoval(int[] beans) {
        int len = beans.length;
        Arrays.sort(beans);
        long sum = 0;
        for(int i = 0; i < len; i++){
            sum = sum + beans[i];
        }
        long minSum = Long.MAX_VALUE;
        for(int i = 0; i < len; i++){
          // 注意转为long
            minSum = Math.min(minSum, sum - (len - i) * (long)beans[i]);
        }
        return minSum;
    }
}

五、总结

这次的周赛成绩还是不理想,希望下次的周赛成绩更好一点~

下一次一定注意类型的转换

加油加油~~~

相关文章
|
7月前
|
Go
golang力扣leetcode 第 291 场周赛
golang力扣leetcode 第 291 场周赛
72 0
|
7月前
|
Go vr&ar
golang力扣leetcode 第 288 场周赛
golang力扣leetcode 第 288 场周赛
56 0
|
7月前
|
Go
golang力扣leetcode第 294 场周赛
golang力扣leetcode第 294 场周赛
61 0
|
7月前
|
算法 Java Go
golang力扣leetcode 第 293 场周赛
golang力扣leetcode 第 293 场周赛
89 0
|
7月前
|
Go
golang力扣leetcode 第 290 场周赛
golang力扣leetcode 第 290 场周赛
54 0
|
7月前
|
Go
golang力扣leetcode 第 292 场周赛
golang力扣leetcode 第 292 场周赛
73 0
|
7月前
|
存储
Leetcode第383场周赛
在LeetCode第383场周赛中,选手完成了3道题目。第一题是关于边界上的蚂蚁,蚂蚁根据非零整数数组nums的值移动,返回蚂蚁返回边界上的次数。解题方法是计算数组累加和为0的次数。第二题涉及计算网格的区域平均强度,给定一个灰度图像和阈值,返回每个像素所属区域的平均强度。解题关键在于理解相邻像素和区域定义,并计算平均强度。第三题是恢复单词初始状态的最短时间问题,通过移除前k个字符并添加k个字符,求恢复原词所需的最短时间。解题策略是检查去除前k个字符后的子串是否能作为原词的前缀。
38 1
Leetcode第383场周赛
|
7月前
|
存储
Leetcode第382场周赛
```markdown 给定字符串`s`,计算按键变更次数,即使用不同键的次数,不考虑大小写差异。例如,`&quot;aAbBcC&quot;`变更了2次。函数`countKeyChanges`实现此功能。另外,求满足特定模式子集最大元素数,`maximumLength`函数使用`TreeMap`统计次数,枚举并构建子集,返回最大长度。最后,Alice和Bob玩鲜花游戏,Alice要赢需满足鲜花总数奇数、顺时针在[1,n]、逆时针在[1,m],返回满足条件的(x, y)对数,可通过奇偶性分类讨论求解。 ```
41 1
|
7月前
|
Go
golang力扣leetcode 第 295 场周赛
golang力扣leetcode 第 295 场周赛
53 0
|
7月前
|
Go
golang力扣leetcode 第 289 场周赛
golang力扣leetcode 第 289 场周赛
457 0